From 8ac9cae9c98be453a465da713233c77cfe9a89bc Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:02 +0000
Subject: [PATCH 883/1001] Feed: add a toggle to show the events of an aggregate


---

diff --git a/hubs/static/client/app/components/feed/Icon.jsx b/hubs/static/client/app/components/feed/Icon.jsx
index 3a15c77..9e0cfbe 100644
--- a/hubs/static/client/app/components/feed/Icon.jsx
+++ b/hubs/static/client/app/components/feed/Icon.jsx
@@ -5,7 +5,7 @@ export default class Icon extends React.Component {
     return (
       <a href={this.props.item.link ? this.props.item.link : '#'}
          target="_blank"
-         className="d-flex align-self-center mr-3"
+         className="d-flex align-self-start mr-3"
          >
         <img
           alt="User avatar"
diff --git a/hubs/static/client/app/components/feed/Markup.jsx b/hubs/static/client/app/components/feed/Markup.jsx
index ad482e0..1ea749e 100644
--- a/hubs/static/client/app/components/feed/Markup.jsx
+++ b/hubs/static/client/app/components/feed/Markup.jsx
@@ -9,19 +9,40 @@ export default class Markup extends React.Component {
     this.createMarkup = this.createMarkup.bind(this);
   }
 
-  createMarkup() {
-    return { __html: this.props.item.markup };
+  createMarkup(item) {
+    return { __html: item.markup || item.subtitle };
   }
 
   render() {
     const timestamp = this.props.item.end_time || this.props.item.timestamp;
+    const submsgs = this.props.item.msg_ids;
+    var submessages = [];
+    if (submsgs && Object.keys(submsgs).length > 1) {
+      submessages = Object.keys(submsgs).map((msgid) => {
+        return (
+          <li key={msgid}>
+            <small dangerouslySetInnerHTML={this.createMarkup(submsgs[msgid])}></small>
+          </li>
+        );
+      });
+    }
 
     return (
-      <div className="media-body align-self-center">
-        <span dangerouslySetInnerHTML={this.createMarkup()}></span>
-        <small className="text-muted float-right">
-          <TimeAgo date={timestamp * 1000} />
-        </small>
+      <div className="media-body align-self-start">
+        <span dangerouslySetInnerHTML={this.createMarkup(this.props.item)}></span>
+        {timestamp &&
+          <small className="text-muted ml-3">
+            <TimeAgo date={timestamp * 1000} />
+          </small>
+        }
+        {submessages.length !== 0 &&
+          <ul
+            className="submessages"
+            style={{display: this.props.detailsOpened ? "block" : "none" }}
+            >
+            {submessages}
+          </ul>
+        }
       </div>
     );
   }
diff --git a/hubs/static/client/app/components/feed/Panel.jsx b/hubs/static/client/app/components/feed/Panel.jsx
index 80bed1c..5be00e7 100644
--- a/hubs/static/client/app/components/feed/Panel.jsx
+++ b/hubs/static/client/app/components/feed/Panel.jsx
@@ -6,14 +6,42 @@ import Actions from './Actions.jsx';
 
 export default class Panel extends React.Component {
 
+  constructor(props) {
+    super(props);
+    this.state = {
+      detailsOpened: false,
+    }
+    this.toggleDetails = this.toggleDetails.bind(this);
+  }
+
+  toggleDetails(e) {
+    e.preventDefault();
+    this.setState((prevState, props) => (
+      {detailsOpened: !prevState.detailsOpened}
+    ));
+  }
+
   render() {
     return (
       <div className="media py-3" id={this.props.item.id}>
         <Icon item={this.props.item} />
-        <Markup {...this.props} />
-        { (this.props.handleSave || this.props.handleUnsave) &&
-          <Actions {...this.props} />
-        }
+        <Markup
+          {...this.props}
+          detailsOpened={this.state.detailsOpened}
+          />
+        <div className="d-flex flex-column align-self-start ml-3 text-right">
+          { (this.props.handleSave || this.props.handleUnsave) &&
+            <Actions {...this.props} />
+          }
+          { (this.props.item.msg_ids &&
+             Object.keys(this.props.item.msg_ids).length > 1) &&
+            <div className="mt-auto">
+              <small>
+                <a href="#" onClick={this.toggleDetails}>details</a>
+              </small>
+            </div>
+          }
+        </div>
       </div>
     );
   }
diff --git a/hubs/static/client/app/components/feed/__tests__/Panel.test.js b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
index 6e17d1c..ff93dbe 100644
--- a/hubs/static/client/app/components/feed/__tests__/Panel.test.js
+++ b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
@@ -14,19 +14,35 @@ describe('Panel', () => {
     date_time: new Date(),
     link: 'https://pagure.io/fedora-hubs',
     secondary_icon: 'https://placekitten.com/g/200/300',
+    msg_ids: {
+      foobar1: {},
+      foobar2: {},
+    },
   };
 
-  it('should render the card block', () => {
+  it('should render the actions block', () => {
     const component = TestUtils.renderIntoDocument(
       <Panel item={item} />
     );
     expect(component).toBeTruthy();
 
     const node = ReactDOM.findDOMNode(component);
-    const block = node.querySelector('.card-block');
+    const block = node.querySelector('div.ml-3.text-right');
 
     expect(block).toBeTruthy();
   });
+
+  it('should show the details link', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Panel item={item} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const details = node.querySelector('.text-right small a');
+
+    expect(details).toBeTruthy();
+  });
 });
 
 

